# author

### hasKey(**publicKey: `Bytes`, keyType: `Text`): `bool`**

* **interface**: `api.rpc.author.hasKey`
* **jsonrpc**: `author_hasKey`
* **summary**: Returns true if the keystore has private keys for the given public key and key type.

### **hasSessionKeys(sessionKeys: `Bytes`): `bool`**

* **interface**: `api.rpc.author.hasSessionKeys`
* **jsonrpc**: `author_hasSessionKeys`
* **summary**: Returns true if the keystore has private keys for the given session public keys.

### **insertKey(keyType: `Text`, suri: `Text`, publicKey: `Bytes`): `Bytes`**

* **interface**: `api.rpc.author.insertKey`
* **jsonrpc**: `author_insertKey`
* **summary**: Inserts a key into the keystore.

### **pendingExtrinsics(): `Vec<Extrinsic>`**

* **interface**: `api.rpc.author.pendingExtrinsics`
* **jsonrpc**: `author_pendingExtrinsics`
* **summary**: Returns all pending extrinsics, potentially grouped by sender

### **removeExtrinsic(bytesOrHash: `Vec<ExtrinsicOrHash>`): `Vec<Hash>`**

* **interface**: `api.rpc.author.removeExtrinsic`
* **jsonrpc**: `author_removeExtrinsic`
* **summary**: Removes given extrinsic from the pool and temporarily ban it to prevent reimporting

### **rotateKeys(): `Bytes`**

* **interface**: `api.rpc.author.rotateKeys`
* **jsonrpc**: `author_rotateKeys`
* **summary**: Generates new session keys and returns the corresponding public keys

### **submitExtrinsic(extrinsic: `Extrinsic`): `Hash`**

* **interface**: `api.rpc.author.submitExtrinsic`
* **jsonrpc**: `author_submitExtrinsic`
* **summary**: Submits a fully formatted extrinsic for block inclusion


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.bifrostnetwork.com/bifrost-network/developer-documentations/client-api/json-rpc-api/author.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
